
HTML-based SHOW 1.2

25.02.1999

Jorma Sajaniemi
Department of Computer Science, University of Joensuu
P.O.Box 111, FIN-80101 Joensuu, Finland
saja@cs.joensuu.fi


RELEASE NOTES
-------------

HTML-based SHOW 1.0 (13.4.1998 Jorma Sajaniemi):
- first release
HTML-based SHOW 1.1 (19.10.1998 Jorma Sajaniemi):
- corrected memory leak that prevented the handling of long files (DOS)
HTML-based SHOW 1.2 (25.02.1999 Jorma Sajaniemi):
- corrected more memory leaks


INTRODUCTION
------------

SHOW is a computer-based classroom presentation system based on the
idea of multi-level teaching materials. The basic idea is to produce
lecture notes, presentation material (to be shown to the students
during lecturing), and teacher's own directions from a single source.
SHOWS includes a program to produce the various versions as well as a
program to present the middle level material to the students. SHOW
uses plain ASCII files.

HTML-based SHOW is a variant of SHOW that relies on HTML editors for
preparing materials and HTML browsers for presentation and printing.
Thus HTML-based SHOW takes only care of creating the various versions
from the single source. HTML-based SHOW recognizes the following
levels:

* teacher's personal directions
* material that is shown in the presentation but not distributed to
  students as part of the lecture notes
* material that is not shown in the presentation but is included in
  the lecture notes
* material that is included in all versions

The author of the original file (i.e., the teacher) marks the
different levels. Normally this is done using different colors but
any other font attribute may be used. The standard coloring scheme is
as follows:

* teacher's personal directions: red
* presentation but not in lecture notes: green
* text for lecture notes only: blue

Text having any other color, e.g., black or other shades of red,
green and blue, is included in all versions.

The system then creates the various versions by discarding parts of
the text depending on the text color. Other elements, like images,
are discarded if the text both before the element and right after it
is discarded. The versions are the following:

* lecture notes
* presentation version
* teacher's full version (everything included; this is essentially a
  copy of the original file)
* teacher's reduced version (text for lecture notes only excluded)


INSTALLATION - UNIX
-------------------

HTML-based SHOW is distributed as a zip-file containing the following
files:

  READ_ME.FST	This file
  prune.c	A C-program that produces a new version with some
		text removed
  make_htm	A shell script that creates the various versions
  example.htm	An example document
  picture.gif	An image needed in the example document

To install HTML-based SHOW you need to have a C compiler.

Installation consists of the following steps:

1. Unzip the zip-file

2. Compile prune.c by typing:

	cc -o prune prune.c

3. Run HTML-based SHOW by typing:

	make_htm example

   This will create the following files:

   _l_example.htm	lecture notes
   _p_example.htm	presentation version
   _r_example.htm	teacher's reduced version
   _t_example.htm 	teacher's full version

   Open these files in your HTML browser and note the differences.


INSTALLATION - DOS/WINDOWS
--------------------------

HTML-based SHOW is distributed as a zip-file containing the following
files:

  READ_ME.FST	This file
  PRUNE.EXE	A program that produces a new version with some
		text removed
  MAKE_HTM.BAT	A batch program that creates the various versions
  HT_TCHER.TXT	A list of colors that count as red
  HT_PRESN.TXT  A list of colors that count as green
  HT_LNOTE.TXT	A list of colors that count as blue
  EXAMPLE.HTM	An example document
  PICTURE.GIF	An image needed in the example document

Installation consists of the following steps:

1. Unzip the zip-file

2. Run HTML-based SHOW by typing in a DOS window:

	make_htm example

   This will create the following files:

   _l_examp.htm	  lecture notes
   _p_examp.htm	  presentation version
   _r_examp.htm	  teacher's reduced version
   _t_examp.htm   teacher's full version

   Open these files in your HTML browser and note the differences.


HOW TO USE HTML-BASED SHOW
--------------------------

To prepare multi-level teaching material with HTML-based SHOW, you
must first create a HTML file where each level has been marked with
color coding (or some other way, see further instructions below). You
can apply color to paragraphs, sentences, words or whatever parts of
text that you don' want to appear in some versions only. If an image
should not appear in all versions, apply version color on text on
both sides of the image.

You can create the original file with any HTML editor, or write HTML
code directly. Use file extension htm (and not html) for your file;
so you now have a HTML file named, say, lecture.htm.

Create the various versions with HTML-based SHOW by running make_htm
(on command prompt in UNIX, and in a DOS window in Windows) by
typing:

	make_htm lecture

Note that you must leave the extension htm out. This will create four
files (in DOS/Windows the names are truncated to 8 characters plus
extension, e.g., _t_lectu.htm):

	_t_lecture.htm	Teacher's full version containing all of the
	              	original file. Print this with your HTML
	              	browser, and have it at hand while lecturing.

	_r_lecture.htm	Teacher's reduced version with text for
	              	lecture notes only discarded. Use this
	              	instead, if the full version is not practical
	              	as an lecturing aid.

	_l_lecture.htm	Lecture notes version. Print this with your
	              	HTML browser, and make copies for your
	              	students.

	_p_lecture.htm	Presentation version that you can project
			for students during lectures. Use your HTML
			browser for projection.


CONFIGURING COLORS
------------------

The most usual way to configure HTML-based SHOW is to change the
colors to suit local needs. For example, personal preferences,
lighting conditions in the presentation room, and the equipment that
is used affect which colors and shades should be used. The default
installation contains the following alternatives for each of the
colors:

* red:   FF0000
* green: 00FF00 33CC00 006600
* blue:  0000FF 3333FF

Thus, for example, colors 0000FF and 3333FF are considered to be blue
and will appear in the lecture notes and in teacher's full version
but not in other versions.

Colors can be changed and new alternatives can be added easily:

UNIX:	 Colors are defined with environment variables TCHER, PRESN
     	 and LNOTE in the file make_htm. The form of an alternative
     	 is

		-s color="#00FF00"

DOS/Win: Colors are defined in files HT_TCHER.TXT, HT_PRESN.TXT and
	 HT_LNOTE.TXT. Each alternative must occupy a line of the
	 following form:

	 	color="#00FF00"

(In UNIX, environment variables are used because they are defined in
one file and it is practical to edit a single file only. In
DOS/Windows, instead, several files are used because I could not
figure out how to include an equal sign in an environment variable in
DOS/Windows (sigh). Both the UNIX and DOS/Windows versions support
exactly same mechanisms, though.)


USING OTHER MARKING PRINCIPLES
------------------------------

It is possible to use any other text attribute (than color) for
marking the levels. For example, if one wants to use colors freely in
all versions, it is possible to mark different levels by font sizes
as follows:

* teacher's personal directions: font size increased by 2
* presentation but not in lecture notes: font size increased by 1
* text for lecture notes only: font size decreased by 1

Text with any other size (e.g., normal size) appears in all versions.

This scheme is implemented in the UNIX version by changing the
definitions of the environment variables TCHER, PRESN and LNOTE in
the file make_htm as follows:

setenv TCHER '-s SIZE=+2'
setenv PRESN '-s SIZE=+1'
setenv LNOTE '-s SIZE=-1'

In the DOS/Windows version the same attributes (without the -s part)
must appear in the *.TXT files, e.g., file HT_TCHER.TXT should be as
follows:

SIZE=+2

Levels cannot be marked with other text properties than attributes
of the <TEXT> tag. For example, properties like bold, underline and
italics are represented in HTML with their own tags (<B>, <U>, <I>)
and hence cannot be used for level marking.


PROBLEMS AND SOLUTIONS
----------------------

Problem:  Text that should not occur in some version appears in that
	  version.

Solution: The color of the text is not exactly any of the colors
	  listed for that version. Look at the HTML file to see what
	  shade has been used for that text, and add this shade to
	  the list as described above.


Problem:  Text that should occur in some version is missing.

Solution: The color of the text is some of the shades listed for
	  some version. Look at the HTML file to see what shade has
	  been used for that text, and remove this shade from the
	  list as described above.


Problem:  Some version has extra empty lines between paragraphs.

Solution: You have marked whole paragraphs but only the text has been
          colored leaving empty lines at both ends without color.
          Make sure that the line breaks are within the color tags
          in the HTML file either at the beginning of a paragraph or
          at the end of it (both not at both).


Problem:  Images or other elements appear in some version although
          the text around them does not.

Solution: When a text block containing an image is colored, some HTML
          editors end the coloring before the image and restart it
          after the image, e.g.,

	  <FONT COLOR="#FF0000"> Red text and then an image: </FONT>
	  <P><IMG SRC="picture.gif"> &nbsp;
	  <FONT COLOR="#FF0000"> and the red text continues. </FONT>

	  To produce the intended result (i.e., the image removed
	  with red text) HTML-based SHOW considers that in such a
	  case the part between the colored texts has the same color
	  as the text on both sides of it provided that the part
	  contains no visible text. In the example above, the part
	  contains a <P> tag, a <IMG ...> tag, and the entity &nbsp;
	  (non-breaking space) i.e., no visible text, and is
	  discarded in versions where red text is removed.

	  HTML-based SHOW considers a part not to contain visible
	  text if it contains tags and non-visible entities only. The
	  problem is that some entities are visible (like &lt; that
	  appears in the browser as <) and some are invisible (like
	  &nbsp;) but there is no systematic way to figure out
	  whether an entity is invisible. HTML-based SHOW has a fixed
	  list of invisible entities:

	  	&hairsp;
	  	&emsp14;
	  	&numsp;
	  	&emsp13;
	  	&ensp;
	  	&nbsp;
	  	&puncsp;
	  	&emsp;
	  	&thinsp;
	  
	  If the part that should be discarded contains an invisible
	  entity that does not appear in the list above, then the
	  part will not be removed. To overcome this problem make a
	  file (say enti.txt) containing such invisible entities one
	  per line (without the preceding ampersand and the trailing
	  semicolon) and change the calls of the prune program in
	  make_htm (UNIX) or MAKE_HTM.BAT (DOS/Windows) to include an
	  extra option:

	  	prune -e enti.txt  ...



CALLING PRUNE DIRECTLY
----------------------

The heart of the HTML-based SHOW is the prune program that takes a
HTML file and produces a new version by discarding some parts of the
original file. This program is called several times in the make_htm
shell script (UNIX) and the MAKE_HTM.BAT batch program (DOS/Windows).
The call has the following form:

	prune options infile outfile

	where infile is the name of the original file, outfile is the
	name of the new file, and options contains any number of the
	following:

	-s xxx		discard text with the font attribute xxx

	-d file		discard text with any font attribute found in
			the file (where each attribute is on its own
			line)

	-e file		consider entities listed in the file (each
	       		attribute on its own line without the
	       		preceding ampersand and the trailing
	       		semicolon) to be invisible (cf. the last
	       		problem in the Problems and Solutions
	       		section)


AUTHORS
-------

The idea of multi-level teaching materials was presented by Jorma
Sajaniemi in December 1996.

The prune program was written by Lasse Rautiainen as a part of his
studies.

The make_htm script was written by Jorma Sajaniemi.
